
use Monetra;

$host = "testbox.monetra.com";
$sslport = 8444;
$regport = 8333;
# METHODs -- 1) IP  2) SSL
$method=2;

print("LIBMONETRA PERL 0.9.0 DEMO (USING MONETRA)\r\n\r\n");
# Location for CA certificates to verify server certificate
Monetra::M_InitEngine("");

$conn=Monetra::M_InitConn();
if ($method == 1) {
  Monetra::M_SetIP($conn, $host, $regport);
} elsif ($method == 2) {
  Monetra::M_SetSSL($conn, $host, $sslport);
  Monetra::M_SetSSL_CAfile($conn, "/usr/local/monetra/CAfile.pem");
}
Monetra::M_SetBlocking($conn, 1);
Monetra::M_SetTimeout($conn, 30);

print("Connecting ...");
if (!Monetra::M_Connect($conn)) {
  $error=Monetra::M_ConnectionError($conn);
  print("Connection failed: $error");
  Monetra::M_DestroyConn($conn);
  Monetra::M_DestroyEngine();
  exit();
}
print("success!\r\n\r\n");

print("Sending transaction:\r\n");
$identifier=Monetra::M_TransNew($conn);
Monetra::M_TransKeyVal($conn, $identifier, "username", "test_ecomm:public");
Monetra::M_TransKeyVal($conn, $identifier, "password", "publ1ct3st");
Monetra::M_TransKeyVal($conn, $identifier, "action", "sale");
Monetra::M_TransKeyVal($conn, $identifier, "account", "4012888888881881");
Monetra::M_TransKeyVal($conn, $identifier, "expdate", "0512");
Monetra::M_TransKeyVal($conn, $identifier, "amount", "65.65");
Monetra::M_TransKeyVal($conn, $identifier, "street", "5800 NW 39th Ave STE 104");
Monetra::M_TransKeyVal($conn, $identifier, "zip", "32606");
Monetra::M_TransKeyVal($conn, $identifier, "cv", "999");
Monetra::M_TransKeyVal($conn, $identifier, "comments", "LIBMONETRA PERL TEST");

if (!Monetra::M_TransSend($conn, $identifier)) {
  print("Failure structuring/sending transaction, probably improperly structured");
  Monetra::M_DestroyConn($conn);
  Monetra::M_DestroyEngine();
  exit();
}

$status=Monetra::M_ReturnStatus($conn, $identifier);

if ($status == Monetra::M_SUCCESS()) {    # Was it good, you may also check agains Monetra::M_FAIL()
  print("Transaction Authorized!!\r\n");
} else {
  print("Transaction Denied!\r\n");
}

$code=Monetra::M_TEXT_Code(Monetra::M_ReturnCode($conn, $identifier));
print("Code: $code\r\n");

$text=Monetra::M_TransactionText($conn, $identifier);
print("Text: $text\r\n");

$ttid=Monetra::M_TransactionID($conn, $identifier);
print("TTID: $ttid\r\n");

$avs=Monetra::M_TEXT_AVS(Monetra::M_TransactionAVS($conn, $identifier));
print("AVS: $avs\r\n");

$cv=Monetra::M_TEXT_CV(Monetra::M_TransactionCV($conn, $identifier));
print("CV: $cv\r\n");

$item=Monetra::M_TransactionItem($conn, $identifier);  # Item number in Batch
print("Item: $item\r\n");

$batch=Monetra::M_TransactionBatch($conn, $identifier); # Batch Number for transaction
print("Batch: $batch\r\n");


if ($status == Monetra::M_SUCCESS()) {
  $auth=Monetra::M_TransactionAuth($conn, $identifier);
  print("auth: $auth\r\n");
}

@list = Monetra::M_ResponseKeys($conn, $identifier);
$num_items = scalar @list;
print("\r\nDump $num_items returned key/value pairs:\r\n");

foreach $item (@list) {
	$val = Monetra::M_ResponseParam($conn, $identifier, $item);
	print("$item = $val\r\n");
}

# OTHER FUNCTIONS OF INTEREST

print("\r\nclosing connection and cleaning up\r\n");
Monetra::M_DestroyConn($conn);
Monetra::M_DestroyEngine();
